#include <iostream>
using namespace std;
#include "csidh.h"

void modular(mpz_class p,std::vector<mpz_class> factors)
{
  natural x(p-1);
  natural y(p-1);
  natural z(p-1);
  natural t;

  long long bitops[bit_opsnum + 10];
  long long pbits = mpz_sizeinbase(p.get_mpz_t(),2);
  long long naturalops[natural_opsnum + 10];

  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  t = x.square();
  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
  for (int cost = 0;cost < bit_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " x^2 " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';

  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  t = x * y;
  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
  for (int cost = 0;cost < bit_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " x*y " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';

  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  t = x.square() % p;
  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
  for (int cost = 0;cost < bit_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " (x^2)%p " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';

  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  t = (x * y) % p;
  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
  for (int cost = 0;cost < bit_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " (x*y)%p " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';

  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  t = (x + y).minimod(p);
  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
  for (int cost = 0;cost < bit_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " (x+y)%p " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';

  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  t = ((x + y).minimod(p) * z) % p;
  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
  for (int cost = 0;cost < bit_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " (((x+y)%p)*z)%p " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';

  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  t = ((x + y) * z) % p;
  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
  for (int cost = 0;cost < bit_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " ((x+y)*z)%p " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';

  for (int e = 1;e <= 10;++e) {
    for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
    for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost);
    t = x.powmod(natural((1<<e)-1),p);
    for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
    for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost) - naturalops[cost];
    for (int cost = 0;cost < bit_opsnum;++cost)
      cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " x^(" << e << "bit)%p " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';
    for (int cost = 0;cost < natural_opsnum;++cost)
      cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " x^(" << e << "bit)%p " << natural::opsname(cost) << ' ' << naturalops[cost] << '\n';
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " x^(" << e << "bit)%p " << "chain" << ' ' << chain_bestW(p-2) << '\n';
  }

  for (int e = 1;e <= 10;++e) {
    for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
    for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost);
    t = x.powpow8mod(natural((1<<e)-1),y,p);
    for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
    for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost) - naturalops[cost];
    for (int cost = 0;cost < bit_opsnum;++cost)
      cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " (x^(" << e << "bit)*y^8)%p " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';
    for (int cost = 0;cost < natural_opsnum;++cost)
      cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " (x^(" << e << "bit)*y^8)%p " << natural::opsname(cost) << ' ' << naturalops[cost] << '\n';
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " (x^(" << e << "bit)*y^8)%p " << "chain" << ' ' << chain_bestW(p-2) << '\n';
  }

  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost);
  t = x.invertmodprime(p);
  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
  for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost) - naturalops[cost];
  for (int cost = 0;cost < bit_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " x^(-1)%p " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';
  for (int cost = 0;cost < natural_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " x^(-1)%p " << natural::opsname(cost) << ' ' << naturalops[cost] << '\n';
  cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " x^(-1)%p " << "chain" << ' ' << chain_bestW(p-2) << '\n';

  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost);
  t = x.powmod((p-1)/2,p);
  for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
  for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost) - naturalops[cost];
  for (int cost = 0;cost < bit_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " legendre(x,p) " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';
  for (int cost = 0;cost < natural_opsnum;++cost)
    cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " legendre(x,p) " << natural::opsname(cost) << ' ' << naturalops[cost] << '\n';
  cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " legendre(x,p) " << "chain" << ' ' << chain_bestW(p-2) << '\n';

  cout << flush;
}

void doit(std::vector<mpz_class> factors)
{
  mpz_class p = 4;
  for (long long i = 0;i < factors.size();++i)
    p *= factors[i];
  p -= 1;

  assert(mpz_probab_prime_p(p.get_mpz_t(),3));

  modular(p,factors);

  for (long long periteration = 1;periteration <= 2;++periteration) {
    long long bitops[bit_opsnum];
    for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost);
  
    long long naturalops[natural_opsnum];
    for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost);
  
    natural A(p-1);
    curve C(p,A);
  
    std::vector<natural> a;
    std::vector<bit> atwist;
  
    for (long long i = 0;i < factors.size();++i)
      a.push_back(natural(5));
    for (long long i = 0;i < factors.size();++i)
      atwist.push_back(bit(1));
    
    auto result = csidh_iteration(C,factors,a,atwist,periteration,1);

    for (int cost = 0;cost < bit_opsnum;++cost) bitops[cost] = bit::ops(cost) - bitops[cost];
    for (int cost = 0;cost < natural_opsnum;++cost) naturalops[cost] = natural::ops(cost) - naturalops[cost];
  
    long long pbits = mpz_sizeinbase(p.get_mpz_t(),2);
  
    for (int cost = 0;cost < bit_opsnum;++cost)
      cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " iteration" << periteration << " " << bit::opsname(cost) << ' ' << bitops[cost] << '\n';
    for (int cost = 0;cost < natural_opsnum;++cost)
      cout << pbits << ' ' << factors[factors.size()-1] << ' ' << p << " iteration" << periteration << " " << natural::opsname(cost) << ' ' << naturalops[cost] << '\n';
  
    cout << flush;
  }
}

int main()
{
  std::vector<mpz_class> factors;

  factors.push_back(3);
  doit(factors);

  factors.push_back(5);
  doit(factors);

  factors.push_back(7);
  doit(factors);

  factors.push_back(11);
  factors.push_back(13);
  factors.push_back(17);
  doit(factors);

  factors.push_back(19);
  doit(factors);

  factors.push_back(23);
  factors.push_back(29);
  factors.push_back(31);
  factors.push_back(37);
  doit(factors);

  factors.push_back(41);
  factors.push_back(43);
  factors.push_back(47);
  factors.push_back(53);
  factors.push_back(59);
  factors.push_back(61);
  factors.push_back(67);
  factors.push_back(71);
  doit(factors);

  factors.push_back(73);
  factors.push_back(79);
  doit(factors);

  factors.push_back(83);
  factors.push_back(89);
  factors.push_back(97);
  factors.push_back(101);
  factors.push_back(103);
  factors.push_back(107);
  factors.push_back(109);
  factors.push_back(113);
  doit(factors);

  factors.push_back(127);
  factors.push_back(131);
  factors.push_back(137);
  factors.push_back(139);
  factors.push_back(149);
  factors.push_back(151);
  factors.push_back(157);
  factors.push_back(163);
  factors.push_back(167);
  factors.push_back(173);
  factors.push_back(179);
  factors.push_back(181);
  factors.push_back(191);
  factors.push_back(193);
  factors.push_back(197);
  factors.push_back(199);
  factors.push_back(211);
  factors.push_back(223);
  factors.push_back(227);
  factors.push_back(229);
  factors.push_back(233);
  factors.push_back(239);
  factors.push_back(241);
  factors.push_back(251);
  factors.push_back(257);
  factors.push_back(263);
  factors.push_back(269);
  factors.push_back(271);
  factors.push_back(277);
  factors.push_back(281);
  factors.push_back(283);
  factors.push_back(293);
  factors.push_back(307);
  factors.push_back(311);
  factors.push_back(313);
  factors.push_back(317);
  factors.push_back(331);
  factors.push_back(337);
  factors.push_back(347);
  factors.push_back(349);
  factors.push_back(353);
  factors.push_back(359);
  factors.push_back(367);
  factors.push_back(373);
  factors.push_back(587);
  doit(factors);

  return 0;
}
