#include <iostream>
using namespace std;
#include "csidh.h"

int main()
{
  mpz_class p("419");
  curve C(p);
  std::vector<mpz_class> factors;
  std::vector<natural> a;
  std::vector<bit> atwist;
  std::vector<natural> b;
  std::vector<bit> btwist;

  factors.push_back(3);
  factors.push_back(5);
  factors.push_back(7);

  a.push_back(natural(3));
  a.push_back(natural(1));
  a.push_back(natural(4));
  atwist.push_back(bit(1));
  atwist.push_back(bit(1));
  atwist.push_back(bit(0));

  b.push_back(natural(2));
  b.push_back(natural(7));
  b.push_back(natural(1));
  btwist.push_back(bit(0));
  btwist.push_back(bit(1));
  btwist.push_back(bit(1));

  curve A = csidh(C,factors,a,atwist,2,8);
  curve B = csidh(C,factors,b,btwist,2,15);

  cout << A.montgomeryA().value() << '\n';
  cout << B.montgomeryA().value() << '\n';

  curve bA = csidh(A,factors,b,btwist,2,10);
  curve aB = csidh(B,factors,a,atwist,2,12);

  cout << bA.montgomeryA().value() << '\n';
  cout << aB.montgomeryA().value() << '\n';

  for (long long loop = 0;loop < 50;++loop) {
    a.resize(0);
    a.push_back(natural(random() & 7));
    a.push_back(natural(random() & 7));
    a.push_back(natural(random() & 7));
    b.resize(0);
    b.push_back(natural(random() & 7));
    b.push_back(natural(random() & 7));
    b.push_back(natural(random() & 7));
    atwist.resize(0);
    atwist.push_back(bit(random() & 1));
    atwist.push_back(bit(random() & 1));
    atwist.push_back(bit(random() & 1));
    btwist.resize(0);
    btwist.push_back(bit(random() & 1));
    btwist.push_back(bit(random() & 1));
    btwist.push_back(bit(random() & 1));

    A = csidh(C,factors,a,atwist,2,20);
    B = csidh(C,factors,b,btwist,2,20);
    bA = csidh(A,factors,b,btwist,2,20);
    aB = csidh(B,factors,a,atwist,2,20);

    assert(bA.montgomeryA().value() == aB.montgomeryA().value());
  }

  a.resize(0);
  a.push_back(natural(0));
  a.push_back(natural(91));
  a.push_back(natural(94));
  b.resize(0);
  b.push_back(natural(0));
  b.push_back(natural(97));
  b.push_back(natural(99));
  atwist.resize(0);
  atwist.push_back(bit(1));
  atwist.push_back(bit(1));
  atwist.push_back(bit(1));
  btwist.resize(0);
  btwist.push_back(bit(1));
  btwist.push_back(bit(0));
  btwist.push_back(bit(0));

  A = csidh(C,factors,a,atwist,2,140);
  B = csidh(C,factors,b,btwist,2,140);
  bA = csidh(A,factors,b,btwist,2,140);
  aB = csidh(B,factors,a,atwist,2,140);

  assert(bA.montgomeryA().value() == aB.montgomeryA().value());

  return 0;
}
