def csidh(E,factors,e):
  for l,ef in zip(factors,e):
    while ef > 0:
      ok = 0
      for r in E.division_polynomial(l).roots():
        x = r[0]
        if E.is_x_coord(x):
          Q = E.lift_x(x)
          assert Q.order() == l
          E = E.isogeny(Q).codomain()
          ok = 1
          break
      assert ok
      ef -= 1
    while ef < 0:
      E = E.quadratic_twist()
      ok = 0
      for r in E.division_polynomial(l).roots():
        x = r[0]
        if E.is_x_coord(x):
          Q = E.lift_x(x)
          assert Q.order() == l
          E = E.isogeny(Q).codomain()
          ok = 1
          break
      assert ok
      E = E.quadratic_twist()
      ef += 1
  return E

def mont(E):
  f = E.two_division_polynomial()
  f = f/f.leading_coefficient()
  r = f.roots()
  assert len(r) == 1
  r = r[0][0]
  f = f(f.variables()[0] + r)
  s = sqrt(f[1])
  if not s.is_square(): s = -s
  return f[2]/s

p = 419
k = GF(p)
E = EllipticCurve(k,[1,0])

factors = [3,5,7]
a = [-3,-1,4]
b = [2,-7,-1]

A = csidh(E,factors,a)
B = csidh(E,factors,b)
print mont(A)
print mont(B)

bA = csidh(A,factors,b)
aB = csidh(B,factors,a)
print mont(bA)
print mont(aB)
