#include <iostream>
using namespace std;
#include "elligator.h"

int main()
{
  int pint = 419;
  mpz_class p(pint);
  mpz_class m;
  int symbol[pint];
  int cover[pint];

  for (int i = 0;i < p;++i) {
    mpz_class exponent = (p-1)/2;
    mpz_class s;
    m = i;
    mpz_powm(s.get_mpz_t(),m.get_mpz_t(),exponent.get_mpz_t(),p.get_mpz_t());
    if (s == 1) symbol[i] = 1;
    else if (s == p-1) symbol[i] = -1;
    else symbol[i] = 0;
  }

  for (int Aint = 1;Aint < p;++Aint) {
    m = (Aint*Aint + p - 4) % p;
    if (symbol[m.get_si()] != -1) continue;
    
    natural A(Aint);
    curve C(p,A);

    for (int i = 0;i < p;++i) cover[i] = 0;
    for (int i = 2;i + i < p;++i) {
      point_affine P = elligator(C,i,bit(0),0);
      mpz_class x = P.xcoordinate().value();
      cout << Aint << " " << i << " 0 " << x << '\n';
      cover[x.get_si()] += 1;
      m = x*x*x+Aint*x*x+x;
      m %= p;
      assert(symbol[m.get_si()] == 1);
    }
    for (int i = 2;i + i < p;++i) {
      point_affine P = elligator(C,i,bit(1),0);
      mpz_class x = P.xcoordinate().value();
      cout << Aint << " " << i << " 1 " << x << '\n';
      cover[x.get_si()] += 1;
      m = x*x*x+Aint*x*x+x;
      m %= p;
      assert(symbol[m.get_si()] == -1);
    }
    for (int i = 0;i < p;++i) assert(cover[i] <= 2);
  }

  return 0;
}
