#include <iostream>
using namespace std;
#include "point.h"

int main()
{
  mpz_class p("419");
  natural A(124);
  curve C(p,A);
  natural x(17);
  point_proj P(C,x);

  cout << "prime " << p << '\n';
  cout << "curve " << A.value() << '\n';
  cout << "point " << P.xcoordinate().value() << '\n';
  assert(C.parent() == p);
  assert(C.montgomeryA().value() == A.value());
  assert(P.parent().parent() == C.parent());
  assert(P.parent().montgomeryA().value() == C.montgomeryA().value());

  for (int n = 0;n < 500;++n) {
    mpz_class ucompare;
    int known = 0;

    for (int b = 0;b < 10;++b)
      if (n < (1 << b)) {
        mpz_class u = (P * natural(n,b)).xcoordinate().value();
        if (known)
          assert(u == ucompare);
	else {
	  ucompare = u;
	  known = 1;
	  cout << n << ' ' << u << '\n';
	}
      }
  }

  return 0;
}
