#include <stdio.h>
#include <stdlib.h>
#include "knownrandom.h"

#define cutoff 1000
#define C 5
#define n 74

int randomexponent(void)
{
  return knownrandom_range(2*C+1)-C;
}

long long x[cutoff];

int main()
{
  int i,E;
  long long loops,iterations,successes;

  for (loops = 0;loops < 10000000;++loops) {
    E = 0;

    for (i = 0;i < n;++i)
      E += abs(randomexponent());

    for (iterations = 0;iterations < cutoff;++iterations) {
      if (E == 0) {
        ++x[iterations];
        break;
      }
      if (knownrandom_range3()) E -= 1;
    }
  }

  successes = 0;
  for (iterations = 0;iterations < cutoff;++iterations) {
    double failure;
    long long e;

    successes += x[iterations];
    failure = 1 - successes / (1.0 * loops);
    e = 0;
    while (failure > 0 && failure < 0.5) {
      failure *= 2;
      e += 1;
    }
    printf("%lld %.3lf * 2^{-%lld} (%lld)\n",iterations,failure,e,x[iterations]);
  }

  return 0;
}
