C = 5
L = (3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 587)
n = len(L)

d = 110
if len(sys.argv) > 1: d = ZZ(sys.argv[1])

scale = 2^50
if len(sys.argv) > 2: scale = 2^ZZ(sys.argv[2])

rounding = floor
if len(sys.argv) > 3:
  rounding = {'upper':floor,'lower':ceil}[sys.argv[3]]

ZZu.<u> = ZZ[]
S.<t> = QQ[[]]

phi = {}
for i in range(d):
  for j in range(i+1):
    for k in range(i-j+1):
      phi[(i,j,k)] = 0
phi[(0,0,0)] = scale

# (i,j,k) entry is probability of (i,j,k)
# i: number of dual-isogeny iterations
# j: number of + isogenies that were put into the bank
# k: number of - isogenies that were put into the bank

for l in reversed(L):
  print 'starting',l
  sys.stdout.flush()

  coin = (l-1)*t/(l-t+O(t^d))
  Ccoins = (coin^(C+1)-coin)/(coin-1)
  Ccoins = [ZZ(rounding(scale*Ccoins[i])) for i in range(d)]
  Ccoinsu = ZZu([Ccoins[d-1-i] for i in range(d)])

  newphi = {}

  for i in range(d):
    for j in range(i+1):
      for k in range(i-j+1):
        newphi[(i,j,k)] = phi[(i,j,k)] * scale

  for i in range(d):
    for k in range(i+1):
      phislice = ZZu([phi[i,j,k] for j in range(i-k+1)])
      phislice *= Ccoinsu
      # coeffs Ccoins[e] phi[i,j,k] u^(d-1+j-e)
      for m in range(i-k+1):
        newphi[(i,m,k)] += phislice[d-1+m]
      for m in range(1,d-i):
        newphi[(i+m,m,k)] += phislice[d-1-m]

  for i in range(d):
    for j in range(i+1):
      phislice = ZZu([phi[i,j,k] for k in range(i-j+1)])
      phislice *= Ccoinsu
      for m in range(i-j+1):
        newphi[(i,j,m)] += phislice[d-1+m]
      for m in range(1,d-i):
        newphi[(i+m,j,m)] += phislice[d-1-m]

  for i in range(d):
    for j in range(i+1):
      for k in range(i-j+1):
        phi[(i,j,k)] = ZZ(rounding(newphi[(i,j,k)] / (scale * (2*C+1))))

succ = 0
for i in range(d):
  for j in reversed(range(i+1)):
    for k in reversed(range(i-j+1)):
      succ += phi[(i,j,k)]

  fail = 1 - succ / scale
  f = 0
  while abs(fail) <= 0.5:
    f += 1
    fail *= 2
  print '%d %.3f * 2^{-%d}' % (i,fail,f)
